diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/test/rectangle-closest-border-test.cc ns-3.40/src/mobility/test/rectangle-closest-border-test.cc
--- ns-3.39/src/mobility/test/rectangle-closest-border-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/mobility/test/rectangle-closest-border-test.cc	2023-09-27 13:30:37.842839700 -0700
@@ -0,0 +1,207 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ */
+
+#include <ns3/rectangle.h>
+#include <ns3/simulator.h>
+#include <ns3/test.h>
+
+using namespace ns3;
+
+/**
+ * \ingroup mobility-test
+ *
+ * \brief Rectangle detection of closest border to a point, inside or outside.
+ */
+class RectangleClosestBorderTestSuite : public TestSuite
+{
+  public:
+    /**
+     * Constructor
+     */
+    RectangleClosestBorderTestSuite();
+};
+
+/**
+ * \ingroup mobility-test
+ *
+ * \brief TestCase to check the rectangle line intersection
+ */
+class RectangleClosestBorderTestCase : public TestCase
+{
+  public:
+    /**
+     * \brief Create RectangleClosestBorderTestCase
+     * \param x Index of the first position to generate
+     * \param y Index of the second position to generate
+     * \param rectangle The 2D rectangle
+     * \param side The expected result of the test
+     */
+    RectangleClosestBorderTestCase(double x, double y, Rectangle rectangle, Rectangle::Side side);
+    /**
+     * \brief Builds the test name string based on provided parameter values
+     * \param x Index of the first position to generate
+     * \param y Index of the second position to generate
+     * \param rectangle The 2D rectangle
+     * \param side The expected result of the test
+     *
+     * \return The name string
+     */
+    std::string BuildNameString(double x, double y, Rectangle rectangle, Rectangle::Side side);
+    /**
+     * Destructor
+     */
+    ~RectangleClosestBorderTestCase() override;
+
+  private:
+    /**
+     * \brief Setup the simulation according to the configuration set by the
+     *        class constructor, run it, and verify the result.
+     */
+    void DoRun() override;
+
+    double m_x{0.0};       //!< X coordinate of the point to be tested
+    double m_y{0.0};       //!< Y coordinate of the point to be tested
+    Rectangle m_rectangle; //!< The rectangle to check the intersection with
+
+    /**
+     * Flag to indicate the intersection.
+     * True, for intersection, false otherwise.
+     */
+    Rectangle::Side m_side{ns3::Rectangle::TOPSIDE};
+};
+
+/**
+ * This TestSuite tests the intersection of a line segment
+ * between two 2D positions with a 2D rectangle. It generates two
+ * positions from a set of predefined positions (see GeneratePosition method),
+ * and then tests the intersection of a line segments between them with a rectangle
+ * of predefined dimensions.
+ */
+
+RectangleClosestBorderTestSuite::RectangleClosestBorderTestSuite()
+    : TestSuite("rectangle-closest-border", UNIT)
+{
+    // Rectangle in the positive x-plane to check the intersection with.
+    Rectangle rectangle = Rectangle(0.0, 10.0, 0.0, 10.0);
+
+    /*            2                3                4
+     *              +----------------------------+ (10,10)
+     *              |  11         16          12 |
+     *              |                            |
+     *              |                            |
+     *      1       |  15          18         17 |              5
+     *              |                            |
+     *              |                            |
+     *              |  10          14         13 |
+     *              +----------------------------+
+     *           9                                  7
+     *           (0,0)
+     *
+     *
+     *
+     *                             8
+     */
+    // Left side (1 and 15)
+    AddTestCase(new RectangleClosestBorderTestCase(-5, 5, rectangle, Rectangle::LEFTSIDE),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(2, 5, rectangle, Rectangle::LEFTSIDE),
+                TestCase::QUICK);
+    // Right side (5 and 17)
+    AddTestCase(new RectangleClosestBorderTestCase(17, 5, rectangle, Rectangle::RIGHTSIDE),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(7, 5, rectangle, Rectangle::RIGHTSIDE),
+                TestCase::QUICK);
+    // Bottom side (8 and 14)
+    AddTestCase(new RectangleClosestBorderTestCase(5, -7, rectangle, Rectangle::BOTTOMSIDE),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(5, 1, rectangle, Rectangle::BOTTOMSIDE),
+                TestCase::QUICK);
+    // Top side (3 and 16)
+    AddTestCase(new RectangleClosestBorderTestCase(5, 15, rectangle, Rectangle::TOPSIDE),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(5, 7, rectangle, Rectangle::TOPSIDE),
+                TestCase::QUICK);
+    // Left-Bottom corner (9 and 10)
+    AddTestCase(new RectangleClosestBorderTestCase(-1, -1, rectangle, Rectangle::BOTTOMLEFTCORNER),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(0, 0, rectangle, Rectangle::BOTTOMLEFTCORNER),
+                TestCase::QUICK);
+    // Right-Bottom corner (7 and 13)
+    AddTestCase(new RectangleClosestBorderTestCase(11, -1, rectangle, Rectangle::BOTTOMRIGHTCORNER),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(9, 1, rectangle, Rectangle::BOTTOMRIGHTCORNER),
+                TestCase::QUICK);
+    // Left-Top corner (2 and 11)
+    AddTestCase(new RectangleClosestBorderTestCase(-1, 11, rectangle, Rectangle::TOPLEFTCORNER),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(1, 9, rectangle, Rectangle::TOPLEFTCORNER),
+                TestCase::QUICK);
+    // Right-Top corner (4 and 12)
+    AddTestCase(new RectangleClosestBorderTestCase(11, 11, rectangle, Rectangle::TOPRIGHTCORNER),
+                TestCase::QUICK);
+    AddTestCase(new RectangleClosestBorderTestCase(9, 9, rectangle, Rectangle::TOPRIGHTCORNER),
+                TestCase::QUICK);
+    // Central position (18)
+    AddTestCase(new RectangleClosestBorderTestCase(5, 5, rectangle, Rectangle::TOPSIDE),
+                TestCase::QUICK);
+}
+
+/**
+ * \ingroup mobility-test
+ * Static variable for test initialization
+ */
+static RectangleClosestBorderTestSuite rectangleClosestBorderTestSuite;
+
+RectangleClosestBorderTestCase::RectangleClosestBorderTestCase(double x,
+                                                               double y,
+                                                               Rectangle rectangle,
+                                                               Rectangle::Side side)
+    : TestCase(BuildNameString(x, y, rectangle, side)),
+      m_x(x),
+      m_y(y),
+      m_rectangle(rectangle),
+      m_side(side)
+{
+}
+
+RectangleClosestBorderTestCase::~RectangleClosestBorderTestCase()
+{
+}
+
+std::string
+RectangleClosestBorderTestCase::BuildNameString(double x,
+                                                double y,
+                                                Rectangle rectangle,
+                                                Rectangle::Side side)
+{
+    std::ostringstream oss;
+    oss << "Rectangle closest border test : checking"
+        << " (x,y) = (" << x << "," << y << ") closest border to the rectangle [(" << rectangle.xMin
+        << ", " << rectangle.yMin << "), (" << rectangle.xMax << ", " << rectangle.yMax
+        << ")]. The expected side = " << side;
+    return oss.str();
+}
+
+void
+RectangleClosestBorderTestCase::DoRun()
+{
+    Vector position(m_x, m_y, 0.0);
+    Rectangle::Side side = m_rectangle.GetClosestSideOrCorner(position);
+
+    NS_TEST_ASSERT_MSG_EQ(side, m_side, "Unexpected result of rectangle side!");
+    Simulator::Destroy();
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc ns-3.40/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc
--- ns-3.39/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/test/steady-state-random-waypoint-mobility-model-test.cc	2023-09-27 13:30:37.842839700 -0700
@@ -106,11 +106,9 @@
     double sum_x = 0;
     double sum_y = 0;
     double sum_v = 0;
-    std::vector<Ptr<MobilityModel>>::iterator i;
-    Ptr<MobilityModel> model;
-    for (i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
+    for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
-        model = (*i);
+        auto model = (*i);
         velocity =
             std::sqrt(std::pow(model->GetVelocity().x, 2) + std::pow(model->GetVelocity().y, 2));
         sum_x += model->GetPosition().x;
@@ -129,9 +127,9 @@
     sum_y = 0;
     sum_v = 0;
     double tmp;
-    for (i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
+    for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
-        model = (*i);
+        auto model = (*i);
         velocity =
             std::sqrt(std::pow(model->GetVelocity().x, 2) + std::pow(model->GetVelocity().y, 2));
         tmp = model->GetPosition().x - mean_x;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mobility/test/waypoint-mobility-model-test.cc ns-3.40/src/mobility/test/waypoint-mobility-model-test.cc
--- ns-3.39/src/mobility/test/waypoint-mobility-model-test.cc	2023-07-05 14:23:48.045428000 -0700
+++ ns-3.40/src/mobility/test/waypoint-mobility-model-test.cc	2023-09-27 13:30:37.842839700 -0700
@@ -105,15 +105,14 @@
     }
 
     // Add the same waypoints to each node
-    std::vector<Ptr<MobilityModel>>::iterator i;
-    for (i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
+    for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
         Ptr<WaypointMobilityModel> mob = (*i)->GetObject<WaypointMobilityModel>();
         mob->TraceConnectWithoutContext(
             "CourseChange",
             MakeCallback(&WaypointMobilityModelNotifyTest::CourseChangeCallback, this));
 
-        for (std::deque<Waypoint>::iterator w = waypoints.begin(); w != waypoints.end(); ++w)
+        for (auto w = waypoints.begin(); w != waypoints.end(); ++w)
         {
             mob->AddWaypoint(*w);
         }
@@ -135,8 +134,7 @@
 void
 WaypointMobilityModelNotifyTest::ForceUpdates()
 {
-    std::vector<Ptr<MobilityModel>>::iterator i;
-    for (i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
+    for (auto i = mobilityStack.begin(); i != mobilityStack.end(); ++i)
     {
         Ptr<WaypointMobilityModel> mob = (*i)->GetObject<WaypointMobilityModel>();
         mob->Update();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/examples/nms-p2p-nix-distributed.cc ns-3.40/src/mpi/examples/nms-p2p-nix-distributed.cc
--- ns-3.39/src/mpi/examples/nms-p2p-nix-distributed.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/examples/nms-p2p-nix-distributed.cc	2023-09-27 13:30:37.842839700 -0700
@@ -78,7 +78,7 @@
 
     uint32_t nCN = 2;
     uint32_t nLANClients = 10;
-    bool single = 0;
+    bool single = false;
     int nPackets = 10; // Packets sent by OnOff applications
     bool nix = true;
     Time stop = Seconds(100);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/model/distributed-simulator-impl.cc ns-3.40/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.39/src/mpi/model/distributed-simulator-impl.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/model/distributed-simulator-impl.cc	2023-09-27 13:30:37.842839700 -0700
@@ -172,7 +172,7 @@
     else
     {
         NodeContainer c = NodeContainer::GetGlobal();
-        for (NodeContainer::Iterator iter = c.Begin(); iter != c.End(); ++iter)
+        for (auto iter = c.Begin(); iter != c.End(); ++iter)
         {
             if ((*iter)->GetSystemId() != MpiInterface::GetSystemId())
             {
@@ -553,7 +553,7 @@
     if (id.GetUid() == EventId::UID::DESTROY)
     {
         // destroy events.
-        for (DestroyEvents::iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
@@ -599,8 +599,7 @@
             return true;
         }
         // destroy events.
-        for (DestroyEvents::const_iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end();
-             i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/model/granted-time-window-mpi-interface.cc ns-3.40/src/mpi/model/granted-time-window-mpi-interface.cc
--- ns-3.39/src/mpi/model/granted-time-window-mpi-interface.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/model/granted-time-window-mpi-interface.cc	2023-09-27 13:30:37.842839700 -0700
@@ -90,7 +90,6 @@
 char** GrantedTimeWindowMpiInterface::g_pRxBuffers;
 MPI_Comm GrantedTimeWindowMpiInterface::g_communicator = MPI_COMM_WORLD;
 bool GrantedTimeWindowMpiInterface::g_freeCommunicator = false;
-;
 
 TypeId
 GrantedTimeWindowMpiInterface::GetTypeId()
@@ -219,16 +218,16 @@
 
     SentBuffer sendBuf;
     g_pendingTx.push_back(sendBuf);
-    std::list<SentBuffer>::reverse_iterator i = g_pendingTx.rbegin(); // Points to the last element
+    auto i = g_pendingTx.rbegin(); // Points to the last element
 
     uint32_t serializedSize = p->GetSerializedSize();
-    uint8_t* buffer = new uint8_t[serializedSize + 16];
+    auto buffer = new uint8_t[serializedSize + 16];
     i->SetBuffer(buffer);
     // Add the time, dest node and dest device
     uint64_t t = rxTime.GetInteger();
-    uint64_t* pTime = reinterpret_cast<uint64_t*>(buffer);
+    auto pTime = reinterpret_cast<uint64_t*>(buffer);
     *pTime++ = t;
-    uint32_t* pData = reinterpret_cast<uint32_t*>(pTime);
+    auto pData = reinterpret_cast<uint32_t*>(pTime);
     *pData++ = node;
     *pData++ = dev;
     // Serialize the packet
@@ -270,9 +269,9 @@
         g_rxCount++; // Count this receive
 
         // Get the meta data first
-        uint64_t* pTime = reinterpret_cast<uint64_t*>(g_pRxBuffers[index]);
+        auto pTime = reinterpret_cast<uint64_t*>(g_pRxBuffers[index]);
         uint64_t time = *pTime++;
-        uint32_t* pData = reinterpret_cast<uint32_t*>(pTime);
+        auto pData = reinterpret_cast<uint32_t*>(pTime);
         uint32_t node = *pData++;
         uint32_t dev = *pData++;
 
@@ -321,14 +320,14 @@
 {
     NS_LOG_FUNCTION_NOARGS();
 
-    std::list<SentBuffer>::iterator i = g_pendingTx.begin();
+    auto i = g_pendingTx.begin();
     while (i != g_pendingTx.end())
     {
         MPI_Status status;
         int flag = 0;
         MPI_Test(i->GetRequest(), &flag, &status);
-        std::list<SentBuffer>::iterator current = i; // Save current for erasing
-        i++;                                         // Advance to next
+        auto current = i; // Save current for erasing
+        i++;              // Advance to next
         if (flag)
         { // This message is complete
             g_pendingTx.erase(current);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/model/null-message-mpi-interface.cc ns-3.40/src/mpi/model/null-message-mpi-interface.cc
--- ns-3.39/src/mpi/model/null-message-mpi-interface.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/model/null-message-mpi-interface.cc	2023-09-27 13:30:37.842839700 -0700
@@ -26,12 +26,12 @@
 
 #include "null-message-mpi-interface.h"
 
+#include "mpi-receiver.h"
 #include "null-message-simulator-impl.h"
 #include "remote-channel-bundle-manager.h"
 #include "remote-channel-bundle.h"
 
 #include "ns3/log.h"
-#include "ns3/mpi-receiver.h"
 #include "ns3/net-device.h"
 #include "ns3/node-list.h"
 #include "ns3/node.h"
@@ -270,23 +270,22 @@
 
     NullMessageSentBuffer sendBuf;
     g_pendingTx.push_back(sendBuf);
-    std::list<NullMessageSentBuffer>::reverse_iterator iter =
-        g_pendingTx.rbegin(); // Points to the last element
+    auto iter = g_pendingTx.rbegin(); // Points to the last element
 
     uint32_t serializedSize = p->GetSerializedSize();
     uint32_t bufferSize = serializedSize + (2 * sizeof(uint64_t)) + (2 * sizeof(uint32_t));
-    uint8_t* buffer = new uint8_t[bufferSize];
+    auto buffer = new uint8_t[bufferSize];
     iter->SetBuffer(buffer);
     // Add the time, dest node and dest device
     uint64_t t = rxTime.GetInteger();
-    uint64_t* pTime = reinterpret_cast<uint64_t*>(buffer);
+    auto pTime = reinterpret_cast<uint64_t*>(buffer);
     *pTime++ = t;
 
     Time guarantee_update =
         NullMessageSimulatorImpl::GetInstance()->CalculateGuaranteeTime(nodeSysId);
     *pTime++ = guarantee_update.GetTimeStep();
 
-    uint32_t* pData = reinterpret_cast<uint32_t*>(pTime);
+    auto pData = reinterpret_cast<uint32_t*>(pTime);
     *pData++ = node;
     *pData++ = dev;
     // Serialize the packet
@@ -313,17 +312,16 @@
 
     NullMessageSentBuffer sendBuf;
     g_pendingTx.push_back(sendBuf);
-    std::list<NullMessageSentBuffer>::reverse_iterator iter =
-        g_pendingTx.rbegin(); // Points to the last element
+    auto iter = g_pendingTx.rbegin(); // Points to the last element
 
     uint32_t bufferSize = 2 * sizeof(uint64_t) + 2 * sizeof(uint32_t);
-    uint8_t* buffer = new uint8_t[bufferSize];
+    auto buffer = new uint8_t[bufferSize];
     iter->SetBuffer(buffer);
     // Add the time, dest node and dest device
-    uint64_t* pTime = reinterpret_cast<uint64_t*>(buffer);
+    auto pTime = reinterpret_cast<uint64_t*>(buffer);
     *pTime++ = 0;
     *pTime++ = guarantee_update.GetInteger();
-    uint32_t* pData = reinterpret_cast<uint32_t*>(pTime);
+    auto pData = reinterpret_cast<uint32_t*>(pTime);
     *pData++ = 0;
     *pData++ = 0;
 
@@ -395,11 +393,11 @@
             MPI_Get_count(&status, MPI_CHAR, &count);
 
             // Get the meta data first
-            uint64_t* pTime = reinterpret_cast<uint64_t*>(g_pRxBuffers[index]);
+            auto pTime = reinterpret_cast<uint64_t*>(g_pRxBuffers[index]);
             uint64_t time = *pTime++;
             uint64_t guaranteeUpdate = *pTime++;
 
-            uint32_t* pData = reinterpret_cast<uint32_t*>(pTime);
+            auto pData = reinterpret_cast<uint32_t*>(pTime);
             uint32_t node = *pData++;
             uint32_t dev = *pData++;
 
@@ -465,14 +463,14 @@
 
     NS_ASSERT(g_enabled);
 
-    std::list<NullMessageSentBuffer>::iterator iter = g_pendingTx.begin();
+    auto iter = g_pendingTx.begin();
     while (iter != g_pendingTx.end())
     {
         MPI_Status status;
         int flag = 0;
         MPI_Test(iter->GetRequest(), &flag, &status);
-        std::list<NullMessageSentBuffer>::iterator current = iter; // Save current for erasing
-        ++iter;                                                    // Advance to next
+        auto current = iter; // Save current for erasing
+        ++iter;              // Advance to next
         if (flag)
         { // This message is complete
             g_pendingTx.erase(current);
@@ -487,9 +485,7 @@
 
     if (g_enabled)
     {
-        for (std::list<NullMessageSentBuffer>::iterator iter = g_pendingTx.begin();
-             iter != g_pendingTx.end();
-             ++iter)
+        for (auto iter = g_pendingTx.begin(); iter != g_pendingTx.end(); ++iter)
         {
             MPI_Cancel(iter->GetRequest());
             MPI_Request_free(iter->GetRequest());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/model/null-message-simulator-impl.cc ns-3.40/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.39/src/mpi/model/null-message-simulator-impl.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/model/null-message-simulator-impl.cc	2023-09-27 13:30:37.842839700 -0700
@@ -140,7 +140,7 @@
     if (MpiInterface::GetSize() > 1)
     {
         NodeContainer c = NodeContainer::GetGlobal();
-        for (NodeContainer::Iterator iter = c.Begin(); iter != c.End(); ++iter)
+        for (auto iter = c.Begin(); iter != c.End(); ++iter)
         {
             if ((*iter)->GetSystemId() != MpiInterface::GetSystemId())
             {
@@ -476,7 +476,7 @@
     if (id.GetUid() == EventId::UID::DESTROY)
     {
         // destroy events.
-        for (DestroyEvents::iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
@@ -522,8 +522,7 @@
             return true;
         }
         // destroy events.
-        for (DestroyEvents::const_iterator i = m_destroyEvents.begin(); i != m_destroyEvents.end();
-             i++)
+        for (auto i = m_destroyEvents.begin(); i != m_destroyEvents.end(); i++)
         {
             if (*i == id)
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/mpi/model/remote-channel-bundle-manager.cc ns-3.40/src/mpi/model/remote-channel-bundle-manager.cc
--- ns-3.39/src/mpi/model/remote-channel-bundle-manager.cc	2023-07-05 14:23:48.049428200 -0700
+++ ns-3.40/src/mpi/model/remote-channel-bundle-manager.cc	2023-09-27 13:30:37.842839700 -0700
@@ -41,8 +41,7 @@
 Ptr<RemoteChannelBundle>
 RemoteChannelBundleManager::Find(uint32_t systemId)
 {
-    ns3::RemoteChannelBundleManager::RemoteChannelMap::iterator kv =
-        g_remoteChannelBundles.find(systemId);
+    auto kv = g_remoteChannelBundles.find(systemId);
 
     if (kv == g_remoteChannelBundles.end())
     {
@@ -78,9 +77,7 @@
 {
     NS_ASSERT(!g_initialized);
 
-    for (RemoteChannelMap::const_iterator iter = g_remoteChannelBundles.begin();
-         iter != g_remoteChannelBundles.end();
-         ++iter)
+    for (auto iter = g_remoteChannelBundles.begin(); iter != g_remoteChannelBundles.end(); ++iter)
     {
         Ptr<RemoteChannelBundle> bundle = iter->second;
         bundle->Send(bundle->GetDelay());
@@ -98,9 +95,7 @@
 
     Time safeTime = Simulator::GetMaximumSimulationTime();
 
-    for (RemoteChannelMap::const_iterator kv = g_remoteChannelBundles.begin();
-         kv != g_remoteChannelBundles.end();
-         ++kv)
+    for (auto kv = g_remoteChannelBundles.begin(); kv != g_remoteChannelBundles.end(); ++kv)
     {
         safeTime = Min(safeTime, kv->second->GetGuaranteeTime());
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/netanim/examples/uan-animation.cc ns-3.40/src/netanim/examples/uan-animation.cc
--- ns-3.39/src/netanim/examples/uan-animation.cc	2023-07-05 14:23:48.057428100 -0700
+++ ns-3.40/src/netanim/examples/uan-animation.cc	2023-09-27 13:30:37.850839600 -0700
@@ -98,7 +98,7 @@
 NetAnimExperiment::UpdatePositions(NodeContainer& nodes) const
 {
     NS_LOG_DEBUG(Simulator::Now().As(Time::S) << " Updating positions");
-    NodeContainer::Iterator it = nodes.Begin();
+    auto it = nodes.Begin();
     Ptr<UniformRandomVariable> uv = CreateObject<UniformRandomVariable>();
     uv->SetAttribute("Min", DoubleValue(0.0));
     uv->SetAttribute("Max", DoubleValue(m_boundary));
